package org.ah.libgdx.demo3dproject.client;

import org.ah.libgdx.demo3dproject.Demo3DProject;

import com.badlogic.gdx.ApplicationListener;
import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.backends.gwt.GwtApplication;
import com.badlogic.gdx.backends.gwt.GwtApplicationConfiguration;
import com.google.gwt.event.logical.shared.ResizeEvent;
import com.google.gwt.event.logical.shared.ResizeHandler;

public class Demo3DProjectHtmlLauncher extends GwtApplication {

    private GwtApplicationConfiguration configuration;
    private Demo3DProject game;

    @Override
    public GwtApplicationConfiguration getConfig() {
        int height = com.google.gwt.user.client.Window.getClientHeight();
        int width = com.google.gwt.user.client.Window.getClientWidth();

        game.resize(width, height);

        com.google.gwt.user.client.Window.enableScrolling(false);
        com.google.gwt.user.client.Window.setMargin("0");

        configuration = new GwtApplicationConfiguration(width, height);
        return configuration;
    }

    @Override
    public ApplicationListener createApplicationListener() {
        game = new Demo3DProject();
        return game;
    }

    @Override
    public ApplicationListener getApplicationListener() {
        return game;
    }

    @Override
    public void onModuleLoad () {
        super.onModuleLoad();
        com.google.gwt.user.client.Window.addResizeHandler(new ResizeHandler() {
              @Override
            public void onResize(ResizeEvent event) {
                  int width = event.getWidth();
                  int height = event.getHeight();
                  Gdx.gl.glViewport(0, 0, width, height);
                  game.resize(width, height);

                  com.google.gwt.user.client.Window.scrollTo((configuration.width - width)/2, (configuration.height - height)/2);

                  Gdx.graphics.setWindowedMode(event.getWidth(), event.getHeight());
              }
            });
    }
}